import controlP5.*;



// var

ControlP5 controlP5;
int ActiveTabe = 1;



// Setup

void Display_Setup () {

  controlP5 = new ControlP5(this);  
  controlP5.tab("default").activateEvent(true);
  controlP5.tab("default").setLabel("Daten");
  controlP5.tab("default").setId(1);
  controlP5.tab("config").activateEvent(true);
  controlP5.tab("config").setLabel("Configuration");
  controlP5.tab("config").setId(2);
  // Config:
  controlP5.addTextfield("valAneoIntervall", 200, 60, 200, 20).setLabel("");  
  controlP5.controller("valAneoIntervall").moveTo("config");
  controlP5.addButton("btnLoggingOnOff", 10, 200, 30, 80, 20).setLabel("none");
  controlP5.controller("btnLoggingOnOff").moveTo("config");
  if (doDatalog == true)
    controlP5.controller("btnLoggingOnOff").setLabel("On");
  else
    controlP5.controller("btnLoggingOnOff").setLabel("Off");

}




// Draw

void Display_Draw () {

  if (ActiveTabe == 1)
    Display_DrawTab1 ();


  if (ActiveTabe == 2)
    Display_DrawTab2 ();
  
}





// Tab 1

void Display_DrawTab1 () {

  // BG
  background (0);
  
  
  // Display data
  for (int i=0;i<arrNodes.size();i++) {
    
    int verticalIndex = 20 + i * 50;
    // Node
    fill(255, 248, 21);
    text ("Node " + arrNodes.get(i), 40, verticalIndex + 50); 
    // Hz
    fill(0);
    rect (200, verticalIndex + 50, 80, -13);
    fill(255);
    text ((String) arrNodesValue1.get(i), 200, verticalIndex + 50); text ("Hz", 230, verticalIndex + 50);  
    // Degree
    fill(0);
    rect (300, verticalIndex + 50, 80, -13);
    fill(255);
    text ((String) arrNodesValue2.get(i), 300, verticalIndex + 50); text ("Degree", 340, verticalIndex + 50);    
    // Pa
    fill(0);
    rect (430, verticalIndex + 50, 80, -13);
    fill(255);
    text ((String) arrNodesValue3.get(i), 430, verticalIndex + 50); text ("Pa", 490, verticalIndex + 50);    
  
  }
  
  

}



// Tab 2

void Display_DrawTab2 () {

  // BG
  background (0);
  

  // Datalog
  fill(0);
  rect (20, 115, 200, -17);
  fill(255);
  text ("Datalog:", 20, 45);
  // Aneometer Intervall
  fill(0);
  rect (20, 155, 200, -13);
  fill(255);
  text ("Aneometer Intervall:", 20, 75);
  // Nodes
  fill(0);
  rect (20, 155, 200, -13);
  fill(255);
  text ("Nodes:", 20, 135);
  // Intervall [ms]
  fill(0);
  rect (160, 155, 200, -13);
  fill(255);
  text ("Intervall [ms]", 160, 135);
  // Pressure
  fill(0);
  rect (340, 155, 200, -13);
  fill(255);
  text ("Diff Pressure [+-Pa]", 340, 135);
  // List Nodes
  for (int i=0;i<arrNodes.size();i++) {
    
    //
    int verticalIndex = 110 + i * 35;
    // Node
    fill(255, 248, 21);
    text ("Node " + arrNodes.get(i), 20, verticalIndex + 50); 
    // Aneometer
    fill(0);
    rect (160, verticalIndex + 50, 80, -13);
    fill(255);
    text ((String) arrNodesAneometerIntervall.get(i), 160, verticalIndex + 50);
    // Pressure
    if (controlP5.controller("txtPressure" + i) == null) {
      
      controlP5.addTextfield("txtPressure" + i, 340, verticalIndex + 35, 80, 20).setLabel("");  
      controlP5.controller("txtPressure" + i).moveTo("config");
    
    }
    // Pressure Diff Value
    fill(0);
    rect (430, verticalIndex + 50, 180, -13);
    fill(255);
    text ((String) arrNodesPressureDiff.get(i), 430, verticalIndex + 50);
    
  }

  
}



// ControlP5 Event

void controlEvent(ControlEvent theControlEvent) {

  // Tab
  if (theControlEvent.isTab())    
    ActiveTabe = theControlEvent.tab().id();
    
  
  // Logging on/off
  if (theControlEvent.controller().name().equals("btnLoggingOnOff")) {
    
    if (doDatalog == true) {
      controlP5.controller("btnLoggingOnOff").setLabel("Off");
      doDatalog = false;
    }
    else {
      controlP5.controller("btnLoggingOnOff").setLabel("On");
      doDatalog = true;
    }
    
  }
  
  
  // Aneometer
  if (theControlEvent.controller().name().equals("valAneoIntervall")) {
    
      String aneoIntervall = theControlEvent.controller().stringValue();
      messanger.sendToAllNodes ('c', "sa" + aneoIntervall); // Set values on Nodes
      messanger.sendToAllNodes ('c', "ra"); // Request values from Nodes

      println("sa" + aneoIntervall);
    
  }
  
  
  // Pressure Diff
  if (theControlEvent.controller().name().substring(0, 11).equals("txtPressure")) {
    
    String nodeId = (String) arrNodes.get (Integer.parseInt (theControlEvent.controller().name().substring(11)));
    String val = theControlEvent.controller().stringValue().trim();
    if (isNumeric (val)) {
      messanger.sendToNode (Integer.parseInt (nodeId), 'P', val);
      messanger.sendToNode (Integer.parseInt (nodeId), 'Q');
    }
    else
      println ("Not Numeric, sorry.");   
    
  }
  
  
  // Debug
  //println(theControlEvent.controller().name());
  
}



public boolean isNumeric(String s) {  
    return java.util.regex.Pattern.matches("\\d+", s);  
}  

